// Copyright 1992 by Jon Dart. All Rights Reserved.
// $Revision: 1.2 $
//
#ifndef _MOVE_GENERATOR_H
#define _MOVE_GENERATOR_H

#include "board.h"
#include "constant.h"

class Move_Generator
{
	public:
		
        enum {MaxMoves = 200};		
		
	Move_Generator( const Board &ABoard, const unsigned ply, const Move pvMove);
	~Move_Generator();
	
	int Generate_Moves( Move *moves, int repeatable  = 0);
	// fills array "moves" with moves, returns # of moves (0 if
        // no more). 
        // 		
        // The moves returned are generally "pseudo-legal", i.e. they may
        // involve moves into check.  However, if the side to move is in
        // check, then all moves returned are strictly legal.		
        
	int Generate_Captures( Move *moves );
	// Like Generate_Moves, but only generates captures, promotions,
        // and check evasions.
		
	unsigned Check_Evasions( Move *moves, int captures_only );
	// returns a list of the moves that may be used to escape
        // check.  Unlike the regular move generation routine, all
        // moves are checked for legality.
        
        unsigned Moves_Generated()
        {
           return moves_generated;
        }
		
	private:
		
	const Board &board;
	int my_ply;
        int moves_generated;
        
	inline void SetMove( const Square source, const Square dest,
		const PieceType promotion,
		Move *moves, unsigned &NumMoves);

};

#endif
